#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD300_faddiff.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

strip_variant_output()
{
    sed -e "s@$SANDPIT/root@@" \
        -e "s/\(Time: *\)[^ ].*/\1BLANKED_BY_$PROGNAME/" \
        -e "s/^\(Version: *\)[^ ].*/\1BLANKED_BY_$PROGNAME/" \
        -e "s/^\(Host: *\)[^ ].*/\1BLANKED_BY_$PROGNAME/"
}

#  WARNING: much of this code is reproduced in another test of fadscan.
echo "creating base directories ..."
mkdir $SANDPIT/{root,scans,elsewhere}

echo "populating base directories ..."
true > $SANDPIT/elsewhere/empty_file
true > $SANDPIT/elsewhere/empty_file2
true > $SANDPIT/root/to_be_deleted
true > $SANDPIT/root/to_be_modified
true > $SANDPIT/root/to_be_chmodded
chmod 666 $SANDPIT/root/to_be_chmodded
ln -s ../elsewhere/empty_file $SANDPIT/root/to_be_repointed
ln $SANDPIT/elsewhere/empty_file $SANDPIT/root/to_be_unhardlinked
touch $SANDPIT/root/to_be_crosslinked_{apple,potato}
ln $SANDPIT/root/to_be_crosslinked_{apple,banana}
ln $SANDPIT/root/to_be_crosslinked_{potato,carrot}
true > $SANDPIT/root/was_file_will_be_directory

echo "scanning ..."
( cd $SANDPIT/root && find . | mkfad ) > $SANDPIT/scans/before.fad

echo "modifying ..."
rm -f $SANDPIT/root/to_be_deleted
echo >> $SANDPIT/root/to_be_modified
true > $SANDPIT/root/to_be_added
chmod 777 $SANDPIT/root/to_be_chmodded
rm -f $SANDPIT/root/to_be_repointed
ln -s nonexistent_file $SANDPIT/root/to_be_repointed
rm -f $SANDPIT/root/to_be_unhardlinked
ln $SANDPIT/elsewhere/empty_file2 $SANDPIT/root/to_be_unhardlinked
rm -f $SANDPIT/root/to_be_crosslinked_{banana,carrot}
ln $SANDPIT/root/to_be_crosslinked_{apple,carrot}
ln $SANDPIT/root/to_be_crosslinked_{potato,banana}
rm $SANDPIT/root/was_file_will_be_directory
mkdir $SANDPIT/root/was_file_will_be_directory

echo "scanning again ..."
( cd $SANDPIT/root && find . | mkfad ) > $SANDPIT/scans/after.fad

echo "diffing ..."
faddiff $SANDPIT/scans/before.fad $SANDPIT/scans/after.fad || true

echo "all done"
