#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD302_faddiff_Jira:FAD-2.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

echo "creating base directories ..."
mkdir $SANDPIT/scans

echo "populating base directories ..."
cat > $SANDPIT/scans/old.fad <<'EOF'
FaDFiLe
FAD-Version: 4
Unix-Time: 1386143338
EOH
$VAR1 = {
          '3763220095658' => {
                                'names' => [
                                             './this-file-will-absolutely-not-change'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 13844,
                                            'inode' => 20095658,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095499' => {
                                'names' => [
                                             '.'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 493,
                                            'content' => 0,
                                            'inode' => 20095499,
                                            'group' => 1000,
                                            'type' => 'd',
                                            'links' => 1
                                          }
                              },
          '3763220095657' => {
                                'names' => [
                                             './this-file-will-not-change'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 10270,
                                            'inode' => 20095657,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095655' => {
                                'names' => [
                                             './this-file-will-change-group'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 5312,
                                            'inode' => 20095655,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095656' => {
                                'names' => [
                                             './this-file-will-change-mode'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 7833,
                                            'inode' => 20095656,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095654' => {
                                'names' => [
                                             './this-file-will-change-owner'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 2655,
                                            'inode' => 20095654,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              }
        };
EOF
    cat > $SANDPIT/scans/new.fad <<'EOF'
FaDFiLe
FAD-Version: 4
Unix-Time: 1386143340
EOH
$VAR1 = {
          '3763220095658' => {
                                'names' => [
                                             './this-file-will-absolutely-not-change'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 13844,
                                            'inode' => 20095658,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095499' => {
                                'names' => [
                                             '.'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 493,
                                            'content' => 0,
                                            'inode' => 20095499,
                                            'group' => 1000,
                                            'type' => 'd',
                                            'links' => 1
                                          }
                              },
          '3763220095657' => {
                                'names' => [
                                             './this-file-will-not-change'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 10270,
                                            'inode' => 20095657,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095655' => {
                                'names' => [
                                             './this-file-will-change-group'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 5312,
                                            'inode' => 20095655,
                                            'group' => 1001,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095656' => {
                                'names' => [
                                             './this-file-will-change-mode'
                                           ],
                                'data' => {
                                            'owner' => 1000,
                                            'dev' => 37632,
                                            'mode' => 421,
                                            'content' => 7833,
                                            'inode' => 20095656,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              },
          '3763220095654' => {
                                'names' => [
                                             './this-file-will-change-owner'
                                           ],
                                'data' => {
                                            'owner' => 1001,
                                            'dev' => 37632,
                                            'mode' => 420,
                                            'content' => 2655,
                                            'inode' => 20095654,
                                            'group' => 1000,
                                            'type' => 'f',
                                            'links' => 1
                                          }
                              }
        };
EOF

echo "diffing with no ignores ..."
faddiff $SANDPIT/scans/old.fad $SANDPIT/scans/new.fad || true

for THING in uid gid mode; do
    echo "diffing with '--ignore-$THING' ..."
    faddiff --ignore-$THING $SANDPIT/scans/old.fad $SANDPIT/scans/new.fad || true
done

echo "all done"
