#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD400_fadfixperms_priv_and_pub.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#
#  SUPPORT FUNCTIONS
#
##############################################################################

echo "creating support directories and files ..."
#  Create prerequisite directories
cd $SANDPIT
mkdir config root
cat > config/test.conf <<EOF
rw-r--r-- ! ! .*/private/diary/.*\.jpg
rwx--x--x ! ! .*/private/diary(|/.*)
rw!r-cr-c ! ! .*/public(|.*)
rw!------ ! ! .*
EOF
mkdir root/private root/public
mkdir root/private/diary root/private/pr0n root/public/icons
mkdir root/private/diary/week1 root/private/diary/week2 root/private/diary/week3 
touch root/private/diary/week1/pic1.jpg
touch root/private/diary/week1/pic2.jpg
touch root/private/diary/week1/pic3.jpg
touch root/private/diary/week2/pic1.jpg
touch root/private/diary/week2/pic2.jpg
touch root/private/diary/week2/pic3.jpg
touch root/private/diary/week3/pic1.jpg
touch root/private/diary/week3/pic2.jpg
touch root/private/diary/week3/pic3.jpg
touch root/public/icons/icon1.jpg
touch root/public/icons/icon2.jpg
touch root/public/icons/icon3.jpg
touch root/private/pr0n/pr0n1.jpg
touch root/private/pr0n/pr0n2.jpg
touch root/private/pr0n/pr0n3.jpg

echo "granting access to all to check correctly revoked ..."
chmod -R go+rwx $SANDPIT/root

echo "fixing perms ..."
find $SANDPIT/root | fadfixperms $SANDPIT/config/test.conf -

echo "displaying perms ..."
find root | LC_ALL=C xargs -n 1 ls -ld | awk '{ print $1 " " $9 }' | sort -k 2

echo "all done"
