#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD401_fadfixperms_lcuinv_at_eso.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#
#  SUPPORT FUNCTIONS
#
##############################################################################

echo "creating support directories and files ..."
#  Create prerequisite directories
cd $SANDPIT
mkdir config root
cat > config/test.conf <<EOF
#  Man pages must be world readable because Debian's man program
#  is setuid 'man', so this 'man' user must be able to read it.
#  This implies that the directories above will also be opened
#  sufficiently to for 'man' to browse down to this.
rw-r--r-- ! ! .*/man/man\d+/.*

#  rest of lcuinv to be open to group (i.e. other vlt users).
!!!c-c--- ! ! .*/opt/lcuinv(|/.*)

#  Default policy: closed
!!!------ ! ! .*
EOF
mkdir root/opt root/opt/lcuinv root/opt/lcuinv/man root/opt/lcuinv/man/man1 root/opt/lcuinv/bin
touch root/opt/lcuinv/man/man1/lcuinv.1 root/opt/lcuinv/bin/lcuinv
chmod 600 root/opt/lcuinv/man/man1/lcuinv.1
chmod 700 root/opt/lcuinv/bin/lcuinv

echo "granting access to all to check correctly revoked ..."
chmod -R go+rwx $SANDPIT/root

echo "fixing perms ..."
find $SANDPIT/root | fadfixperms $SANDPIT/config/test.conf -

echo "displaying perms ..."
find root | LC_ALL=C xargs -n 1 ls -ld | awk '{ print $1 " " $9 }' | sort -k 2

echo "all done"
