#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD402_fadfixperms_setuid_setgid_sticky.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#
#  SUPPORT FUNCTIONS
#
##############################################################################

echo "creating support directories and files ..."
#  Create prerequisite directories
cd $SANDPIT
mkdir config root
cat > config/test.conf <<EOF
#  Man pages must be world readable because Debian's man program
#  is setuid 'man', so this 'man' user must be able to read it.
#  This implies that the directories above will also be opened
#  sufficiently to for 'man' to browse down to this.
rwxr-xr-x ! ! .*/normal
rwsr-xr-x ! ! .*/setuid
rwxr-sr-x ! ! .*/setgid
rwxr-xr-t ! ! .*/sticky
rwSr--r-- ! ! .*/SETUID
rw-r-Sr-- ! ! .*/SETGID
rw-r--r-T ! ! .*/STICKY
rwsr-sr-t ! ! .*/all
rwSr-Sr-T ! ! .*/ALL
!!!!!!!!! ! ! .*/preserve
rwsr-cr-c ! ! .*/copy
--------- ! ! .*/strip
rw!c-cc-c ! ! .*
EOF
touch root/normal
touch root/setuid
touch root/setgid
touch root/sticky
touch root/SETUID
touch root/SETGID
touch root/STICKY
touch root/all
touch root/ALL
touch root/preserve
touch root/copy
touch root/strip
chmod 7777 root/strip root/copy root/preserve

echo "fixing perms ..."
find $SANDPIT/root | fadfixperms $SANDPIT/config/test.conf -

echo "displaying perms ..."
find root | LC_ALL=C xargs -n 1 ls -ld | awk '{ print $1 " " $9 }' | LC_ALL=C sort -k 2

echo "all done"
