#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD403_fadfixperms_access_above_symlink.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#
#  SUPPORT FUNCTIONS
#
##############################################################################

echo "creating support directories and files ..."
#  Create prerequisite directories
cd $SANDPIT
mkdir config root
cat > config/test.conf <<EOF
#  Allow root access to the symlink so it can be access through correct path.
!!!r-xr-x ! ! .*/bin/pc008887/mumc
#  Default policy: closed
!!!------ ! ! .*
EOF
mkdir -p root/bin/pc008887
( cd root/bin/pc008887 && ln -s ../../opt/Fedora_3_i386/mumc/bin/mumc )

echo "revoking access to all to check correctly granted ..."
chmod -R go-rwx $SANDPIT/root

echo "fixing perms ..."
find $SANDPIT/root | fadfixperms $SANDPIT/config/test.conf -

echo "displaying perms ..."
find root | LC_ALL=C xargs -n 1 ls -ld | awk '{ print $1 " " $9 }' | LC_ALL=C sort -k 2

echo "all done"
