#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD405_fadfixperms.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#
#  SUPPORT FUNCTIONS
#
##############################################################################

getuid()
{
    id | sed 's/uid=\([0-9][0-9]*\).*/\1/'
}

getgid()
{
    id | sed 's/.*gid=\([0-9][0-9]*\).*/\1/'
}

echo "creating support directories and files ..."
#  Create prerequisite directories
mkdir $SANDPIT/config $SANDPIT/root $SANDPIT/tmp
cat > $SANDPIT/config/test.conf <<EOF
!!!------ ! ! .*make_private.*
!!!c-cc-c ! ! .*make_public.*
!!!------ ! ! .*
EOF
mkdir $SANDPIT/root/subdir_a
mkdir $SANDPIT/root/subdir_b
mkdir $SANDPIT/root/subdir_c
mkdir $SANDPIT/root/subdir_d
true > $SANDPIT/root/subdir_a/make_private_aa
true > $SANDPIT/root/subdir_a/make_private_ab
true > $SANDPIT/root/subdir_b/make_public_ba
true > $SANDPIT/root/subdir_b/make_private_bb
true > $SANDPIT/root/subdir_c/make_private_ca
true > $SANDPIT/root/subdir_c/make_public_cb
true > $SANDPIT/root/subdir_d/make_public_da
true > $SANDPIT/root/subdir_d/make_public_db

echo "preparing permissions for run #1 ..."
chmod -R go-rwx $SANDPIT/root

echo "fixing for run #1 ..."
find $SANDPIT/root | fadfixperms $SANDPIT/config/test.conf -

( cd $SANDPIT/root && find . -ls ) | awk '{ printf "%s %s\n", $3, $11 }' | sort -k 2r

echo "doing mkfad of run #1 results ..."
find $SANDPIT/root | mkfad > $SANDPIT/tmp/run1.fad

echo "preparing permissions for run #2 ..."
chmod -R go+rwx $SANDPIT/root

echo "fixing for run #2 ..."
find $SANDPIT/root | fadfixperms $SANDPIT/config/test.conf -

echo "doing mkfad of run #2 results ..."
find $SANDPIT/root | mkfad > $SANDPIT/tmp/run2.fad

echo "checking diffs ...."
faddiff $SANDPIT/tmp/run1.fad $SANDPIT/tmp/run2.fad

echo "all done"
