#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD502_mkfad.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#                           
#  Purpose of test: to verify that the 'other names' a hard-linked file has
#                   are always put in the same order in a fad record whatever
#		    the order of links in the directory catalogue.
#
##############################################################################

echo "creating base directories ..."
mkdir $SANDPIT/root $SANDPIT/scans

echo "creating 'order 1' files ..."
mkdir $SANDPIT/root/order_1 
true > $SANDPIT/root/order_1/file_1
ln $SANDPIT/root/order_1/file_1 $SANDPIT/root/order_1/file_2
ln $SANDPIT/root/order_1/file_1 $SANDPIT/root/order_1/file_3
#  if they were unordered then it would be:
#  1: 2 3
#  2: 1 3
#  3: 1 2

echo "creating 'order 2' files ..."
mkdir $SANDPIT/root/order_2
true > $SANDPIT/root/order_2/file_3
ln $SANDPIT/root/order_2/file_3 $SANDPIT/root/order_2/file_2
ln $SANDPIT/root/order_2/file_3 $SANDPIT/root/order_2/file_1
#  if they were unordered then it would be:
#  1: 3 2
#  2: 3 1
#  3: 2 1

echo "scanning 'order 1' ..."
( cd $SANDPIT/root/order_1 && find . | mkfad ) > $SANDPIT/scans/order_1.fad
echo "scanning 'order 2' ..."
( cd $SANDPIT/root/order_2 && find . | mkfad ) > $SANDPIT/scans/order_2.fad

echo "diffing ..."
faddiff $SANDPIT/scans/order_1.fad $SANDPIT/scans/order_2.fad

echo "all done"
