#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD600_fadcat.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#                           
#  Purpose of test: to verify that the 'other names' a hard-linked file has
#                   are always put in the same order in a fad record whatever
#		    the order of links in the directory catalogue.
#
##############################################################################

echo "creating .fad file ..."
cat > $SANDPIT/input.fad <<'EOF'
FaDFiLe
FAD-Version: 4
Unix-Time: 1201456044
EOH
$VAR1 = {
          '205225248550' => {
                               'names' => [
                                            'ref/FAD002_fadfixperms'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 4676,
                                           'type' => 'f',
                                           'inode' => 25248550,
                                           'links' => 1
                                         }
                             },
          '205225248542' => {
                               'names' => [
                                            'ref/FAD009_fadfixperms_uid_root'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 22165,
                                           'type' => 'f',
                                           'inode' => 25248542,
                                           'links' => 1
                                         }
                             },
          '205225248549' => {
                               'names' => [
                                            'ref/FAD600_fadcat'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 27390,
                                           'type' => 'f',
                                           'inode' => 25248549,
                                           'links' => 1
                                         }
                             },
          '205225248547' => {
                               'names' => [
                                            'ref/FAD401_fadfixperms_lcuinv_at_eso'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 1483,
                                           'type' => 'f',
                                           'inode' => 25248547,
                                           'links' => 1
                                         }
                             },
          '205225248555' => {
                               'names' => [
                                            'ref/FAD400_fadfixperms_priv_and_pub'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 25315,
                                           'type' => 'f',
                                           'inode' => 25248555,
                                           'links' => 1
                                         }
                             },
          '205225248392' => {
                               'names' => [
                                            'ref'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 493,
                                           'content' => 0,
                                           'type' => 'd',
                                           'inode' => 25248392,
                                           'links' => 1
                                         }
                             },
          '205225248552' => {
                               'names' => [
                                            'ref/FAD001_fadscan'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 14672,
                                           'type' => 'f',
                                           'inode' => 25248552,
                                           'links' => 1
                                         }
                             },
          '205225248541' => {
                               'names' => [
                                            'ref/FAD003_mkfad'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 11748,
                                           'type' => 'f',
                                           'inode' => 25248541,
                                           'links' => 1
                                         }
                             },
          '205225248543' => {
                               'names' => [
                                            'ref/FAD006_fadfixperms_alternating'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 23825,
                                           'type' => 'f',
                                           'inode' => 25248543,
                                           'links' => 1
                                         }
                             },
          '205225248545' => {
                               'names' => [
                                            'ref/FAD004_faddiff'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 14154,
                                           'type' => 'f',
                                           'inode' => 25248545,
                                           'links' => 1
                                         }
                             },
          '205225248554' => {
                               'names' => [
                                            'ref/FAD403_fadfixperms_access_above_symlink'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 21007,
                                           'type' => 'f',
                                           'inode' => 25248554,
                                           'links' => 1
                                         }
                             },
          '205225248553' => {
                               'names' => [
                                            'ref/FAD402_fadfixperms_setuid_setgid_sticky'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 32008,
                                           'type' => 'f',
                                           'inode' => 25248553,
                                           'links' => 1
                                         }
                             },
          '205225248546' => {
                               'names' => [
                                            'ref/FAD005_uri_filenames'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 14876,
                                           'type' => 'f',
                                           'inode' => 25248546,
                                           'links' => 1
                                         }
                             },
          '205225248548' => {
                               'names' => [
                                            'ref/FAD007_fadfixperms_symlinks'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 19772,
                                           'type' => 'f',
                                           'inode' => 25248548,
                                           'links' => 1
                                         }
                             },
          '205225248551' => {
                               'names' => [
                                            'ref/FAD008_fadfixperms_invalid_uidgid'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 15814,
                                           'type' => 'f',
                                           'inode' => 25248551,
                                           'links' => 1
                                         }
                             },
          '205225248544' => {
                               'names' => [
                                            'ref/FAD500_mkfad_hardlinks'
                                          ],
                               'data' => {
                                           'owner' => 1000,
                                           'group' => 1000,
                                           'dev' => 2052,
                                           'mode' => 420,
                                           'content' => 68,
                                           'type' => 'f',
                                           'inode' => 25248544,
                                           'links' => 1
                                         }
                             }
        };
EOF

echo "piping .fad file through fadcat ..."
fadcat < $SANDPIT/input.fad > $SANDPIT/output.fad
echo "comparing results ..."
faddiff $SANDPIT/input.fad $SANDPIT/output.fad
rm -f $SANDPIT/output.fad

echo "piping .fad file through fadcat -o ..."
fadcat -o $SANDPIT/output.fad < $SANDPIT/input.fad
echo "comparing results ..."
faddiff $SANDPIT/input.fad $SANDPIT/output.fad
rm -f $SANDPIT/output.fad

echo "all done"
