#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD700_fadscan_basic.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

##############################################################################
#
#  SUPPORT FUNCTIONS
#
##############################################################################

getuid()
{
    id | sed 's/uid=\([0-9][0-9]*\).*/\1/'
}

getgid()
{
    id | sed 's/.*gid=\([0-9][0-9]*\).*/\1/'
}

strip_variant_data()
{
sed \
	-e "s@[^ 	]*/$SANDPIT_BASENAME@@" \
	-e "s/^\(Host\|Start-Time\|Last-Refresh-Time\|Version\|End-Time\)\(: *\)[^ ].*/\1\2BLANKED_OUT_BY_$PROGNAME/"
}

SANDPIT_BASENAME="$(basename "$SANDPIT")"

echo "creating support directories and files ..."
#  Create prerequisite directories
mkdir $SANDPIT/config $SANDPIT/state $SANDPIT/log $SANDPIT/root $SANDPIT/tmp
cat > $SANDPIT/config/test <<EOF
#!/bin/bash
find $SANDPIT/root
EOF
chmod 755 $SANDPIT/config/test
true > $SANDPIT/root/file_to_change
true > $SANDPIT/root/file_to_delete
sleep 10

echo "initialising scan ..."
$SANDPIT/config/test | fadscan --state-dir=$SANDPIT/state --log-dir=$SANDPIT/log -i test -

echo "checking scan ..."
$SANDPIT/config/test | fadscan --state-dir=$SANDPIT/state --log-dir=$SANDPIT/log -c test -
zcat $SANDPIT/log/test-*.gz | strip_variant_data

echo "changing the root ..."
date > $SANDPIT/root/file_to_change
rm $SANDPIT/root/file_to_delete
true > $SANDPIT/root/file_to_add
sleep 10

echo "scheduling a refresh ..."
fadscan --state-dir=$SANDPIT/state --log-dir=$SANDPIT/log -s test

echo "checking scan again, which should show diffs ..."
$SANDPIT/config/test | fadscan --state-dir=$SANDPIT/state --log-dir=$SANDPIT/log -c test -
zcat $SANDPIT/log/test-*.gz | strip_variant_data

echo "checking scan again, which should not show diffs ..."
$SANDPIT/config/test | fadscan --state-dir=$SANDPIT/state --log-dir=$SANDPIT/log -c test -
zcat $SANDPIT/log/test-*.gz | strip_variant_data

echo "all done"
