#!/bin/bash
#  $HeadURL: https://svn.pasta.freemyip.com/main/fad/tags/7/tests/bin/FAD701_fadscan_all_change_types.sh $ $LastChangedRevision: 10265 $
PROGNAME=`basename $0`
SANDPIT=`pwd`
. $(ade-config ade_share_prefix)/include/adetestsupport.sh

strip_variant_output()
{
    sed -e "s@$SANDPIT/root@@" \
        -e "s/\(Time: *\)[^ ].*/\1BLANKED_BY_$PROGNAME/" \
        -e "s/^\(Version: *\)[^ ].*/\1BLANKED_BY_$PROGNAME/" \
        -e "s/^\(Host: *\)[^ ].*/\1BLANKED_BY_$PROGNAME/"
}

#  WARNING: much of this code is reproduced in another test of fadscan.
echo "creating base directories ..."
mkdir $SANDPIT/{root,scans,elsewhere,etc,state,log}

echo "populating base directories ..."
true > $SANDPIT/elsewhere/empty_file
true > $SANDPIT/elsewhere/empty_file2
true > $SANDPIT/root/to_be_deleted
true > $SANDPIT/root/to_be_modified
true > $SANDPIT/root/to_be_chmodded
chmod 666 $SANDPIT/root/to_be_chmodded
ln -s ../elsewhere/empty_file $SANDPIT/root/to_be_repointed
ln $SANDPIT/elsewhere/empty_file $SANDPIT/root/to_be_unhardlinked
touch $SANDPIT/root/to_be_crosslinked_{apple,potato}
ln $SANDPIT/root/to_be_crosslinked_{apple,banana}
ln $SANDPIT/root/to_be_crosslinked_{potato,carrot}
true > $SANDPIT/root/was_file_will_be_directory

{
    echo "#!/bin/bash"
    echo find $SANDPIT/root
} > $SANDPIT/etc/test
chmod 755 $SANDPIT/etc/test

echo "scanning ..."
$SANDPIT/etc/test | fadscan --log-dir=$SANDPIT/log --state-dir=$SANDPIT/state -i test -

echo "modifying ..."
rm -f $SANDPIT/root/to_be_deleted
date >> $SANDPIT/root/to_be_modified
true > $SANDPIT/root/to_be_added
chmod 777 $SANDPIT/root/to_be_chmodded
rm -f $SANDPIT/root/to_be_repointed
ln -s nonexistent_file $SANDPIT/root/to_be_repointed
rm -f $SANDPIT/root/to_be_unhardlinked
ln $SANDPIT/elsewhere/empty_file2 $SANDPIT/root/to_be_unhardlinked
rm -f $SANDPIT/root/to_be_crosslinked_{banana,carrot}
ln $SANDPIT/root/to_be_crosslinked_{apple,carrot}
ln $SANDPIT/root/to_be_crosslinked_{potato,banana}
rm -f $SANDPIT/root/was_file_will_be_directory
mkdir $SANDPIT/root/was_file_will_be_directory

echo "scanning again ..."
$SANDPIT/etc/test | fadscan --log-dir=$SANDPIT/log --state-dir=$SANDPIT/state -c test -

echo "diffing ..."
zcat $SANDPIT/log/* | strip_variant_output

echo "all done"
